%define need_kernel	2.6.16

Name: xen
Version: 3.0.2
Release: aw0

Summary: Xen is a Virtual Machine Monitor
Group: Emulators
License: GPL
Url: http://www.cl.cam.ac.uk/Research/SRG/netos/xen/

Source0: %name-3.0-testing-src.tgz
# list of files and directories are removed from kernel-source-xen
Source1: %name-%version-alt-exclude

Patch1: %name-%version-alt-remove-lsb.patch
Patch2: %name-%version-alt-python.patch
Patch3: %name-%version-alt-mkbuildtree-fix.patch
Patch4: %name-%version-alt-vnc.patch
Patch5: %name-%version-alt-build.patch
Patch6: %name-%version-alt-fix-bridge-start.patch

Packager: XEN Maintainers Team <xen@packages.altlinux.org>

# Automatically added by buildreq on Tue Mar 14 2006
BuildRequires: dev86 esound-devel ghostscript-classic ghostscript-common ghostscript-module-X ghostscript-utils latex2html libSDL-devel libX11-devel libXext-devel libalsa-devel libaudiofile-devel libe2fs-devel libgimp-print libjpeg-devel libncurses-devel libtinfo-devel libvncserver-devel netpbm perl-DBM python-base python-dev python-modules-compiler python-modules-encodings python-modules-logging tetex-core tetex-dvips tetex-latex transfig urw-fonts xorg-x11-proto-devel zlib-devel

BuildPreReq: kernel-build-tools glib2-devel

Requires: bridge-utils python-module-twisted python-module-xen

%description
Xen is a Virtual Machine Monitor (VMM) originally developed by the
Systems Research Group of the University of Cambridge Computer
Laboratory, as part of the UK-EPSRC funded XenoServers project.
Xen is freely-distributable Open Source software, released under the
GNU GPL.

%package -n python-module-xen
Summary: Python binding's for XEN
Group: System/Libraries

%description -n python-module-xen
Xen is a Virtual Machine Monitor (VMM) originally developed by the
Systems Research Group of the University of Cambridge Computer
Laboratory, as part of the UK-EPSRC funded XenoServers project.
Xen is freely-distributable Open Source software, released under the
GNU GPL.

This package contains python binding's for XEN.

%package -n python-module-grub
Summary: python-module-grub
Group: System/Libraries

%description -n python-module-grub
python-module-grub

%package -n lib%name
Summary: Shared libraries for XEN
Group: System/Libraries

%description -n lib%name
Xen is a Virtual Machine Monitor (VMM) originally developed by the
Systems Research Group of the University of Cambridge Computer
Laboratory, as part of the UK-EPSRC funded XenoServers project.
Xen is freely-distributable Open Source software, released under the
GNU GPL.

This package contains the XEN shared libraries.

%package -n lib%name-devel
Summary: Development files for XEN
Group: Development/C

Requires: lib%name = %version

%description -n lib%name-devel
Xen is a Virtual Machine Monitor (VMM) originally developed by the
Systems Research Group of the University of Cambridge Computer
Laboratory, as part of the UK-EPSRC funded XenoServers project.
Xen is freely-distributable Open Source software, released under the
GNU GPL.

This package contains the XEN include files and development libraries
required when building applications which are going to use XEN shared
libraries.

%package -n lib%name-devel-static
Summary: Static libraries for lib%name
Group: Development/C

Requires: lib%name-devel = %version

%description -n lib%name-devel-static
Xen is a Virtual Machine Monitor (VMM) originally developed by the
Systems Research Group of the University of Cambridge Computer
Laboratory, as part of the UK-EPSRC funded XenoServers project.
Xen is freely-distributable Open Source software, released under the
GNU GPL.

This package contains the XEN static libraries.

%package docs
Summary: Documentation for XEN
Group: Books/Computer books

%description docs
Xen is a Virtual Machine Monitor (VMM) originally developed by the
Systems Research Group of the University of Cambridge Computer
Laboratory, as part of the UK-EPSRC funded XenoServers project.
Xen is freely-distributable Open Source software, released under the
GNU GPL.

This package contains the XEN documentation in PostScript and PDF
formats.

%package -n kernel-source-xen-%need_kernel
Group: Development/Other
Summary: Kernel patches for Xen

%description -n kernel-source-xen-%need_kernel
Kernel patches for Xen

%prep
%setup -n xen-3.0-testing
%patch1 -p1
%patch2 -p1
%patch3 -p1 
%patch4 -p1 
%patch5 -p1 
%patch6 -p1 

%build
%__tar --exclude-from=%SOURCE1 -cvjf xen-source-%need_kernel-%version.tar.bz2 linux-2.6-xen-sparse xen patches buildconfigs Makefile Config.mk

# ugly hack for building python binding's // begin
pushd tools/libxc
%make_build
popd

pushd tools/xenstore
%make_build
popd

pushd tools/misc
%make_build
popd

pushd tools/xcutils
%make_install
popd

# ugly hack for building python binding's // end

# build python binding's for xen // begin
pushd tools/python

%__mkdir_p build

# Unfortunately build and install steps should be done at once
# because otherwise .pyo files won't get into INSTALLED_FILES
# record

CFLAGS="%optflags" %__python setup.py \
	install --optimize=2 \
		--root=`pwd`/build \
		--record=../../INSTALLED_FILES
popd

pushd tools/pygrub

%__mkdir_p build

CFLAGS="%optflags" %__python setup.py \
	install --optimize=2 \
		--root=`pwd`/build \
		--record=../../INSTALLED_FILES_GRUB
popd

# build python binding's for xen // end

%make_build xen tools docs

%install
# install python binding's for xen // begin
pushd tools/python/
%__mkdir_p %buildroot/usr
%__cp -pr build/usr/* %buildroot/usr
popd

pushd tools/pygrub/
%__cp -pr build/usr/* %buildroot/usr
popd

# install python binding's for xen // end

# install all other tools
%make_install install-xen install-tools install-docs DESTDIR=%buildroot

pushd tools/examples
%make_install install-udev install-hotplug DESTDIR=%buildroot
popd

#fix
%__mkdir_p %buildroot{%kernel_src,%_sysconfdir/rc.d}
%__install -m644 xen-source-%need_kernel-%version.tar.bz2 %buildroot%kernel_src
%__cp -r dist/install/etc/hotplug %buildroot%_sysconfdir/hotplug
%__cp -r %buildroot%_sysconfdir/init.d %buildroot%_sysconfdir/rc.d/init.d
%__mv -f %buildroot%_sysconfdir/udev/xen-backend.rules %buildroot%_sysconfdir/udev/rules.d/

%post -n lib%name
%post_ldconfig

%postun -n lib%name
%postun_ldconfig

%files
%config(noreplace) %_sysconfdir/xen
%config(noreplace) %_sysconfdir/rc.d/init.d/*
%config(noreplace) %_sysconfdir/hotplug/*
%config(noreplace) %_sysconfdir/sysconfig/*
%config(noreplace) %_sysconfdir/udev/rules.d/*
/boot/*
%_bindir/*
%_sbindir/*
%_man1dir/*
%_man5dir/*
%_man8dir/*
%_datadir/xen/*
/var/lib/xenstored
/var/run/xenstored
%exclude %_libdir/python2.4
%exclude /etc/init.d

%files -n python-module-xen -f INSTALLED_FILES

%files -n python-module-grub -f INSTALLED_FILES_GRUB

%files -n lib%name
%_libdir/lib*.so.*
%_libdir/libxenstore.so
%_libdir/xen
%ifarch x86_64
    /usr/lib/xen/boot/hvmloader
%endif

%files -n lib%name-devel
%_libdir/lib*.so
%_includedir/*.h
%dir %_includedir/xen/
%_includedir/xen/*.h
%_includedir/xen/io/*.h
%_includedir/xen/linux/*.h

%files -n lib%name-devel-static
%_libdir/lib*.a

%files docs
%doc %_datadir/doc/xen/*

%files -n kernel-source-xen-%need_kernel
%kernel_src/*

%changelog
* Wed Aug 16 2006 Denis Pynkin <d.pynkin@sam-solutions.net> 3.0.2-aw0
- added buildconfigs, Makefile, Config.mk to xen-source
- added tools/misc compiling (needed for mbootpack tool). not yet packed.

* Sat Jun 24 2006 Alex Yustasov <yust@altlinux.ru> 3.0.2-alt3
- fixed build for x86_64: hvmloader

* Fri Jun 23 2006 Alex Yustasov <yust@altlinux.ru> 3.0.2-alt2
- fixed bridge start

* Thu Jun 08 2006 Alex Yustasov <yust@altlinux.ru> 3.0.2-alt1
- update to 3.0.2-3-testing

* Tue Feb 07 2006 Alex Yustasov <yust@altlinux.ru> 3.0.1-alt2
- update to 3.0.1

* Mon Jan 30 2006 Igor Zubkov <icesik@altlinux.ru> 3.0.0-alt1
- update to 3.0.0

* Sat Nov 19 2005 Igor Zubkov <icesik@altlinux.ru> 2.0.7-alt2
- fix build with "_unpackaged_files_terminate_build 1"

* Sat Oct 22 2005 Igor Zubkov <icesik@altlinux.ru> 2.0.7-alt1
- Initial build for Sisyphus
